/*
M4r10;
Copyright (C) 2005  Jean-Franois Geyelin
email: jfgeyelin@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "all.h"

//main.c
static inline void PLAY();
void reverse_all_ennemies();
//static inline void init_coins();
//move.c
void init_green_fireball(GREEN_FIREBALL_STRUCT *  ,MINI_FIREBALL_STRUCT * ,short );
void move_coin(COIN_STRUCT *);
void move_ennemi(ENNEMI_STRUCT *);
void load_waiting_line(ENNEMI_STRUCT*);
void empty_waiting_line(short);
void launch_new_coin(short);
void move_crabe(ENNEMI_STRUCT *);
void move_turtle(ENNEMI_STRUCT *);
void move_bee(ENNEMI_STRUCT *);
void move_iceman(ENNEMI_STRUCT *);
void move_green_fireball(GREEN_FIREBALL_STRUCT * ,MINI_FIREBALL_STRUCT *);
void create_new_coin_going_out(short,COIN_OUT_PIPE*);
void move_coin_out(COIN_OUT_PIPE *);
void move_coin_in(COIN_IN_PIPE *);
void create_new_eip(ENNEMI_STRUCT *);
//stalag.c
void create_stalag(STALAG_STRUCT*);
void move_stalag(STALAG_STRUCT*);
void init_small_explosion(EXPLODING_STALAG_STRUCT *,STALAG_STRUCT*);
//draw.c
void Pixel4(short,short,short,short);
void draw_map(ENNEMI_STRUCT *, short, short);//napo.
void draw_ennemi(ENNEMI_STRUCT *,short, short);
void draw_mario(PLAYER_STRUCT*,short,short);
void draw_coin(COIN_STRUCT*, short, short);
void draw_anim(ANIMATION_STRUCT *, short , short );
void draw_score_anim(SCORE_ANIMATION_STRUCT * , short , short);
void draw_stalag(STALAG_STRUCT* , short, short);
void draw_frozen_ground(FREEZE_GROUND_STRUCT*);
void draw_exploding_icemen(short ,short, short);
void draw_dead_anim(DEAD_ENNEMI_ANIMATION_STRUCT * , short , short);
void draw_respawn(PLAYER_STRUCT * , short, short );
void draw_score(long);
void draw_masked_pipes(short, short);
void draw_fireball(FIREBALL_STRUCT *, short , short );
void draw_mini_fireball(MINI_FIREBALL_STRUCT * , short , short);
void draw_exploding_stalag(EXPLODING_STALAG_STRUCT *,short ,short );
void draw_coin_io(COORD_STRUCT* ,short, short);
void draw_ennemi_out(ENNEMI_OUT_PIPE * ,short , short);
void draw_ennemi_in(ENNEMI_IN_PIPE * ,short, short);
//intro.c
short menu();
//collsiion.c
short hit_left(PLAYER_STRUCT *);
short hit_right(PLAYER_STRUCT *);
short hit_top(PLAYER_STRUCT *);
short hit_bottom(PLAYER_STRUCT *);
short hit_left(PLAYER_STRUCT *);
short hit_bottom2(ENNEMI_STRUCT *);
short hit_bottom3(ENNEMI_STRUCT *);
short check_for_pow(PLAYER_STRUCT*,short*);
void init_collision();
void check_if_fireball_explodes(GREEN_FIREBALL_STRUCT *, MINI_FIREBALL_STRUCT * , short ,short ,PLAYER_STRUCT *);
void delete_ennemi_in_array(ENNEMI_STRUCT *);
void delete_coin_in_array(COIN_STRUCT *);
void check_all_collision();
char on_ice(PLAYER_STRUCT *);
void detect_collision_with_coin(PLAYER_STRUCT *,COIN_STRUCT*);
void detect_collision_with_ennemi(PLAYER_STRUCT *,ENNEMI_STRUCT* );
void detect_collision_with_fireball(PLAYER_STRUCT * ,GREEN_FIREBALL_STRUCT *);
short collide_with_small_stalag(STALAG_STRUCT* ,PLAYER_STRUCT *);
void kill_player(PLAYER_STRUCT *p);
//score.c
void update_score(unsigned long , short);

char (*map)[32];
char (*map_collision)[38];


static void (*move_ennemies[])(ENNEMI_STRUCT *) = {move_turtle,move_crabe,move_bee,move_iceman};

char * pl;//Plane Light
char * pd;//Plane Dark
short number_of_ennemies_in_level;
short number_of_coin_to_init;
char *vecran;

COLLISION_ENNEMI* colis;
Plane fg_plane;
ENNEMI_STRUCT ** ennemi_to_be_initialized;
COIN_STRUCT * coins;
ANIMATION_STRUCT * anim;
SCORE_ANIMATION_STRUCT * score_anim;
STALAG_STRUCT * stalag;
EXPLODING_ICEMEN_STRUCT * exploding_icemen;
DEAD_ENNEMI_ANIMATION_STRUCT * dead_anim;
FREEZE_GROUND_STRUCT * freeze_g;
COIN_IN_PIPE *cip;
ENNEMI_OUT_PIPE *eop;
ENNEMI_IN_PIPE *eip;
short number_of_icemen_explosion;
  

static char not_enough_mem[] = "Not enough memory to launch M4r10";

void _main(void)
{
	#define M_MAP_SIZE 32*50
	#define M_COLLIS_SIZE 38*38
  INT_HANDLER ai1=ai1,ai5=ai5;
  char *bloc1=malloc(
										  M_MAP_SIZE +
										  M_COLLIS_SIZE +
										  sizeof(STALAG_STRUCT)*MAX_NUMBER_OF_STALAG+
										  sizeof(COIN_STRUCT)*MAX_NUMBER_OF_COIN+
										  sizeof(COLLISION_ENNEMI)*NUMBER_OF_LINES+
										  sizeof(ANIMATION_STRUCT)*MAX_ANIM+
										  sizeof(SCORE_ANIMATION_STRUCT)*MAX_ANIM+
										  sizeof(ENNEMI_STRUCT**)*MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT+
										 	sizeof(DEAD_ENNEMI_ANIMATION_STRUCT)*MAX_DEAD_ANIM+
										 	sizeof(EXPLODING_ICEMEN_STRUCT)*MAX_EXPLODING_ICEMEN+
										 	sizeof(FREEZE_GROUND_STRUCT)*MAX_NUMBER_OF_FREEZE_G+
										 	sizeof(COIN_IN_PIPE)*MAX_COIN_IO+
										 	sizeof(ENNEMI_OUT_PIPE)*MAX_ENNEMI_IO+
										 	sizeof(ENNEMI_IN_PIPE)*MAX_ENNEMI_IO
										  );
  if(!bloc1) {
		ST_helpMsg(not_enough_mem);	
  	return;
  }
  char *bloc2=malloc(GRAY_BIG_VSCREEN_SIZE+LCD_SIZE*5);
  if(!bloc2) {
  	free(bloc1);
		ST_helpMsg(not_enough_mem);	
  	return;
  }

	//INITIALISATION POUR LE BLOC1
	map =  (char(*)[32])bloc1;
	map_collision = (char(*)[38])(bloc1+M_MAP_SIZE);;
	stalag = (STALAG_STRUCT*)(map_collision+M_COLLIS_SIZE);
	coins = (COIN_STRUCT*)(((char*)stalag)+sizeof(STALAG_STRUCT)*MAX_NUMBER_OF_STALAG);
	colis = (COLLISION_ENNEMI*)(((char*)coins)+sizeof(COIN_STRUCT)*MAX_NUMBER_OF_COIN);
	anim = (ANIMATION_STRUCT*)(((char*)colis)+sizeof(COLLISION_ENNEMI)*NUMBER_OF_LINES);
	score_anim = (SCORE_ANIMATION_STRUCT*)(((char*)anim)+sizeof(ANIMATION_STRUCT)*MAX_NUMBER_OF_COIN);
	ennemi_to_be_initialized = (ENNEMI_STRUCT**)(((char*)score_anim)+sizeof(SCORE_ANIMATION_STRUCT)*MAX_ANIM);
	dead_anim = (DEAD_ENNEMI_ANIMATION_STRUCT*)(((char*)ennemi_to_be_initialized)+sizeof(ENNEMI_STRUCT**)*MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT);
	exploding_icemen = (EXPLODING_ICEMEN_STRUCT*)(((char*)dead_anim)+sizeof(DEAD_ENNEMI_ANIMATION_STRUCT)*MAX_DEAD_ANIM);
	freeze_g = (FREEZE_GROUND_STRUCT*)(((char*)exploding_icemen)+sizeof(EXPLODING_ICEMEN_STRUCT)*MAX_EXPLODING_ICEMEN);
	cip = (COIN_IN_PIPE*)(((char*)freeze_g)+sizeof(FREEZE_GROUND_STRUCT)*MAX_NUMBER_OF_FREEZE_G);
	eop = (ENNEMI_OUT_PIPE*)(((char*)cip)+sizeof(COIN_IN_PIPE)*MAX_COIN_IO);
	eip = (ENNEMI_IN_PIPE*)(((char*)eop)+sizeof(ENNEMI_OUT_PIPE)*MAX_ENNEMI_IO);
	//INITIALISATION POUR LE BLOC2
	char* save_screen = bloc2;
  pd = 										(char*)bloc2+1*LCD_SIZE;
  pl = 										(char*)bloc2+2*LCD_SIZE;
  vecran = 								(char*)bloc2+3*LCD_SIZE;
  fg_plane.big_vscreen = 	(char*)(bloc2+5*LCD_SIZE);
  memcpy(save_screen,LCD_MEM,LCD_SIZE);
  /*
  LE RESTE DES INITIALISATIONS POUR LES 2 PLANS...
  */
  fg_plane.matrix=map;
  fg_plane.width=32;
  fg_plane.sprites=sprite;
  fg_plane.force_update=1;
	//interruptions...
  ai1=GetIntVec(AUTO_INT_1);
  ai5=GetIntVec(AUTO_INT_5);
  SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
  SetIntVec(AUTO_INT_5,DUMMY_HANDLER); 
	if (GrayOn()) {
  	while (menu()) {
	    PLAY();
    }
    GrayOff();
		memcpy(LCD_MEM,save_screen,LCD_SIZE);
//		ST_helpMsg(":: jfgeyelin@gmail.com ::");
		ST_helpMsg("boo!");
  }
  else
  {
		memcpy(LCD_MEM,save_screen,LCD_SIZE);
		ST_helpMsg(not_enough_mem);		
	}	
  while (_keytest(RR_ENTER));
  GKeyFlush();
  SetIntVec(AUTO_INT_5,ai5);
  SetIntVec(AUTO_INT_1,ai1);
  free(bloc1);
  free(bloc2);
}


void ChangeContrast() {
	if (_keytest(RR_PLUS))
	OSContrastUp();
	if (_keytest(RR_MINUS))
	OSContrastDn();			
}



void reverse_all_ennemies(PLAYER_STRUCT* p) {
	short i,j;
	OBJECT_STRUCT* s;
	for (i=NUMBER_OF_LINES;i--;) {
		if (colis[i].test_line) {
			for (j=MAX_NUMBER_OF_THING_PER_LINES;j--;) {
				s = (OBJECT_STRUCT*)colis[i].s[j];
				if (s != NULL) {
					s->must_be_reversed=TRUE;
					s->reversed_p = p;
					s->reversed_vx = 0;
				}
			}
		}
	}
}




static inline void reverse_some_ennemies(short x, short y,PLAYER_STRUCT *p) {
	x+=6;
	OBJECT_STRUCT** s= (OBJECT_STRUCT**)&colis[(y>>3)+1].s[0];
	short i,d;
	for (i=MAX_NUMBER_OF_THING_PER_LINES;i--;) {	
		if (s[i] != NULL) {
			d = ((s[i]->s_x)>>H_S)-x+s[i]->middle;
			if (abs(d)<10) {
				s[i]->must_be_reversed = TRUE;
				s[i]->reversed_p = p;
				s[i]->reversed_vx=d<<3;
			}
		}
	}
}


/*

*/
void init_ennemi(ENNEMI_STRUCT* e, short x) {
  e->sprite = ennemie_sprites[x];
  e->move_function_id  = x;
  e->X.must_be_reversed = FALSE;
  e->X.id = x;
  e->speed = 0;
  e->reserved = TRUE;
  e->was_hit_once = FALSE;
}




static inline void PLAY() {
	/***********************************
	Creation of the various variables...
	************************************/

	//The array of structure containing the info for the ennemies.
	ENNEMI_STRUCT e[MAX_ENNEMIES];	
	//structure to handle the deformated floor
	FLOOR_ANIMATION_STRUCT an[2];
	//Structure to handle the manual scrolling
	SCROLLING_STRUCT scro;
	
	//Structure containing info 4 the player
	PLAYER_STRUCT p;
	//Structure containing info 4 the fireballz
	GREEN_FIREBALL_STRUCT green_fireball;
	MINI_FIREBALL_STRUCT mf[1];

	EXPLODING_STALAG_STRUCT ex_stalag[MAX_NUMBER_OF_STALAG];
	//Pipes struct, the one that will tell us when to inject a new monster/coin in the level
	PIPES_STRUCT pipes[2];


	//Array for the masked in/out coin
	COIN_OUT_PIPE cop[MAX_COIN_IO];
	/*ENNEMI_IN_PIPE cip[MAX_COIN_IO];	*/
	
	

	short level_num=0;
	short time=0;
  short x_fg=x_fg,y_fg=y_fg;
 	short x,y;
  short pow_has_been_hit;  
 	char show_level_num = show_level_num;
 	char show_clear = show_clear;
  short key_was_pressed=key_was_pressed;
  short i;
  char jump_to_next_level;
  //variables containing info for every level
	char slipice_on;
	char stalag_on;
	char fireball_on;
	char turtle_in_lvl;
	char crabe_in_lvl;
	char bee_in_lvl;
	char quit;
	p.score = 0;
	p.score_till_new_life = 0;
	p.lives = 2;		
	do {
	  level_num++;
	  
		/**********************************
		Initializations of all the variables
		***********************************/
		pow_has_been_hit = 0;
		quit = FALSE;
		//Player initializations
	  p.s_x = 66<<H_S;
	  p.s_y = (276)<<V_S;
	  p.s_vy = 0;
	  p.s_vx = 0;
	  p.dir = DIR_RIGHT;
	  p.hit_top = FALSE;
	  p.time_until_gravity = 0;
	  p.step = 0;
	  p.inter_step = 0;
	  p.dead = FALSE;
		p.d.stuned_time = 0;
		p.show_gg = FALSE;
		p.re.time_down = 0;
		p.re.block_time = 0;
		//manual scrolling initialization
		scro.dir = 0;
		scro.value = 0;
		show_level_num = 100; 
		show_clear = FALSE;
		jump_to_next_level = FALSE;
		//floor animation init
	  an[0].time = 0;
	  an[1].time = 0;
	  an[0].sprite = sprite[8];
	  an[0].x = 0;
	  an[0].y = 8;
	  //Init the num of the...
	  number_of_icemen_explosion=0;
	  //Fireballz init
	 	mf[0].on = FALSE;	
		green_fireball.on = FALSE;
		//Level param init

		static unsigned char DpTurtle[]=		{3,2,2,1,0,0,2,4,2,2,1,1};
		static unsigned char DpCrabe[]=			{0,1,2,1,2,3,2,0,1,2,2,2};
		static unsigned char DpBee[]=				{0,0,0,1,2,3,2,0,1,0,2,2};
		static unsigned char DpFireball[]=	{0,0,0,0,0,1,1,0,1,0,1,1};
		static unsigned char DpSlipice[]=		{0,0,0,0,0,0,0,1,1,0,0,1};
		static unsigned char DpStalag[]=		{0,0,0,0,0,0,0,0,0,1,1,1};
		
		short DifficultyLevel = (level_num-1)%12;
		short DifficultyBonus = (level_num-1)/12;
		
		turtle_in_lvl = DpTurtle[DifficultyLevel]+DifficultyBonus;
		crabe_in_lvl	= DpCrabe[DifficultyLevel]+DifficultyBonus;
		bee_in_lvl 		= DpBee[DifficultyLevel]+DifficultyBonus;
		fireball_on 	= DpFireball[DifficultyLevel]|DifficultyBonus;
		slipice_on 		= DpSlipice[DifficultyLevel]|DifficultyBonus;
		stalag_on 		= DpStalag[DifficultyLevel]|DifficultyBonus;


		if ((level_num%5)==1) {
		//Copy the map into a modifiable one
		memcpy(map,real_map,32*50);
		memcpy(map_collision,map_collision_static,38*38);
		}
		else
		{
			for (i=32*50;i--;) {
				if (map[0][i] == 73)
				map[0][i] = 1;
			}
		}
		
		fg_plane.force_update=1;
		//want free...?
		if (_keytest(RR_X) && _keytest(RR_F5)) {	
			for (i=0;i<28;i++) {
				map[28][i+2] = 107+i;
				map[22][i+2] = 107+i;
				map[18][i+2] = 107+i;
			}
		}
		//Initialize the stalag animations and freeze the ground
		if (stalag_on) {
			for (i=32;i--;)
			map[19][i] = (map[19][i]==1?73:0);
		  for (i=MAX_NUMBER_OF_STALAG;i--;) {
		  	stalag[i].animation_on = FALSE;
		  	ex_stalag[i].time = 0;
		  }
		}
		//Initialize the coins that may end up on screen
		for (i=MAX_NUMBER_OF_COIN;i--;) {
			coins[i].visible=FALSE;
			coins[i].X.middle=4;
		}
		number_of_coin_to_init = 0;
	  //De-synchronize the 2 pipes
	  pipes[0].time = 20;
	  pipes[1].time = 10;
	  //Init the collision table
		for (y=NUMBER_OF_LINES;y--;) {
			colis[y].test_line = FALSE;
			for (x=32;x--;)
			colis[y].test_line|=map_collision[y][x];//if colis[y].test_line == TRUE, then we must test the line (this is to increase the speed)
			for (x=MAX_NUMBER_OF_THING_PER_LINES;x--;) {
				colis[y].s[x] = NULL;
			}
		}
		//Init the score animations.
		for (i=MAX_ANIM;i--;) {
		  anim[i].time = 0;
		  score_anim[i].time = 0;
		}
		//Init the ennemi structures
	  for (i=MAX_ENNEMIES;i--;) {
	  	e[i].reserved = FALSE;
	 		e[i].visible = FALSE;
	 		ennemi_to_be_initialized[i]=NULL;
	  }
	  
	  
	  for (i=MAX_ENNEMI_IO;i--;) {
	  	eop->time = 0;
	  	eip->time = 0;
	  }
	  //ngetchx();
	  
	  
	  //Init the waiting line
		number_of_ennemies_in_level = turtle_in_lvl+crabe_in_lvl+bee_in_lvl;//how many monster remains to be killed
		for (i=0;i<turtle_in_lvl;i++)//Fill it with turtle
		init_ennemi(&(e[i]),0);
		for (;i<turtle_in_lvl+crabe_in_lvl;i++)//Fill it with crabe
		init_ennemi(&(e[i]),1);
		for (;i<turtle_in_lvl+crabe_in_lvl+bee_in_lvl;i++)//Fill it with bees
		init_ennemi(&(e[i]),2);
	  for (i=0;i<MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT;i++) {//Fill my "waiting line"
			if (e[i].reserved)   
			load_waiting_line(&(e[i]));
	  }
	  //Init the struct containing info for the death  animation of the ennemies
	  for (i=MAX_DEAD_ANIM;i--;)
	  dead_anim[i].on = FALSE;
	  //Init the coins
	  for (i=MAX_COIN_IO;i--;) {
	  	cop[i].time=0;
	  	cip[i].time=0;
	  }
	  //Init the animation to freeze the ground
	  for (i=MAX_NUMBER_OF_FREEZE_G;i--;)
	  freeze_g[i].on = FALSE;
	  
	  do
	  {			
	  
	  
			if (_keytest(RR_ESC)) {
				if (!p.lives && p.dead) {
					quit = 1;
				}
				else
				{
					
					#define MAP_W						34
					#define PAUSE_W 				112
					#define PAUSE_H 				40
					#define PAUSE_Y_OFFSET 	20
					#define X_CORNER ((LCD_WIDTH-PAUSE_W)/2)
					#define Y_CORNER ((LCD_HEIGHT-PAUSE_H)/2)
					short XxXx = ((LCD_WIDTH-MAP_W)/2);
					short YyYy = 5;
					draw_map(e,XxXx,YyYy);
					GrayDrawRect2B(X_CORNER,Y_CORNER+PAUSE_Y_OFFSET,X_CORNER+PAUSE_W,Y_CORNER+PAUSE_H+PAUSE_Y_OFFSET, COLOR_BLACK,RECT_FILLED,GrayGetPlane(0),GrayGetPlane(1));
					GrayDrawRect2B(X_CORNER+1,Y_CORNER+1+PAUSE_Y_OFFSET,X_CORNER+PAUSE_W-1,Y_CORNER+PAUSE_H-1+PAUSE_Y_OFFSET, COLOR_LIGHTGRAY,RECT_FILLED,GrayGetPlane(0),GrayGetPlane(1));
					GrayDrawRect2B(X_CORNER+4,Y_CORNER+4+PAUSE_Y_OFFSET,X_CORNER+PAUSE_W-4,Y_CORNER+PAUSE_H-4+PAUSE_Y_OFFSET, COLOR_DARKGRAY,RECT_EMPTY,GrayGetPlane(0),GrayGetPlane(1));
					GraySpriteX8_MASK(X_CORNER+8*3+4,Y_CORNER+8+PAUSE_Y_OFFSET,8,continue_1,continue_1,continue_mask,continue_mask,8,GrayGetPlane(0),GrayGetPlane(1));
					GraySpriteX8_MASK(X_CORNER+8*3+4,Y_CORNER+8+16+PAUSE_Y_OFFSET,8,quit_1,quit_1,quit_mask,quit_mask,4,GrayGetPlane(0),GrayGetPlane(1));
					quit=0;
					XxXx++;
					YyYy--;
					short change=TRUE;
					short jyaif = 0;
					short j=j;
					while (!_keytest(RR_ENTER)) {
						
						if ((j&63) == 0)
						ChangeContrast();
						j++;
						pokeIO(0x600005,0b11101);
						jyaif++;
						if (jyaif==66) {
							Pixel4(A_XOR,(p.s_x>>(H_S+3))+XxXx,(p.s_y>>(V_S+3))+YyYy,p.dir);
							jyaif=0;
						}
						if (_keytest(RR_UP)) {
							change = quit==1;
							quit=0;
						}
						if (_keytest(RR_DOWN)) {
							change = quit==0;
							quit=1;
						}
						if (change) {
							change = FALSE;
							for (i=24;i--;) {
								*(((char*)GrayGetPlane(LIGHT_PLANE))+((X_CORNER+8)/8+(Y_CORNER+8+i+PAUSE_Y_OFFSET)*30))=0b11111111;
								*(((char*)GrayGetPlane(DARK_PLANE))+((X_CORNER+8)/8+(Y_CORNER+8+i+PAUSE_Y_OFFSET)*30))=0b00000000;						
							}
							GraySprite8_MASK(X_CORNER+8,(quit?PAUSE_Y_OFFSET+Y_CORNER+24:PAUSE_Y_OFFSET+Y_CORNER+8),8,curso_1,curso_1,curso_mask,curso_mask,GrayGetPlane(0),GrayGetPlane(1));
						}
					}
				}
			}
			
			
	  	/***********************************
	  	*
	  	*	Gestion des mouvements du joueur
	  	*
	  	***********************************/
	
    	if (_keytest(RR_UP) || _keytest(RR_DOWN)) {
    		
    		if (_keytest(RR_UP)) {
    			if (scro.value!=-40)
    			scro.value-=2;
    		}
    		else
    		{
    			if (scro.value!=40)
    			scro.value+=2;  			
    		}
    	}
    	else 
    	{
				if (scro.value) {
					if (scro.value>0)
					scro.value-=2;
					else
					scro.value+=2;
				}

	    }
	    
			
			if (p.dead || show_clear) {
	   	 p.s_x = p.last_frame_s_x;
	   	 p.s_y = p.last_frame_s_y;
	   	}
	   	else
	   	{
	    	p.last_frame_s_x = p.s_x;
	   	 	p.last_frame_s_y = p.s_y;  		
		    //Dplacement vert
		    p.x = p.s_x >> (H_S);
		    if (!(_keytest(RR_F1) || _keytest(RR_2ND)))
		    p.time_until_gravity = 0;
		    if (p.hit_top == FALSE) {//Si perso n'est pas coinc sous block
			    if (hit_bottom(&p)) {//Si il y a sol sous les pied	    	
			    	if ((_keytest(RR_F1) || _keytest(RR_2ND) )) {
			      	p.s_vy=-260;
			      	p.s_y += p.s_vy;
			      	p.time_until_gravity = 15;
			      }
			    }
			    else//Si il n'y a pas de sol sous les pieds
			    {
			    	p.time_until_gravity-=(p.time_until_gravity!=0);
			    	if ((p.time_until_gravity==0)) {
			    		p.s_vy+=15;
			    		if (p.s_vy>100)
			    		p.s_vy = 100;
			    	}
			    	p.s_y +=p.s_vy;
					 	while (hit_bottom(&p)) {
							p.s_y -= 1<< 6;
						}
					  p.s_y += 1<<6;			  
					}
				}
				else//Si perso est coinc sous block
				{
					p.time_until_down--;
					p.hit_top = p.time_until_down >= 0;
				}
				hit_top(&p);
		    if (hit_top(&p) && p.hit_top == FALSE) {
		    	p.hit_top = TRUE;
					p.time_until_gravity = 0;
		    	while (hit_top(&p))
		    	p.s_y += 1<<6;
					if (check_for_pow(&p,&pow_has_been_hit))
					reverse_all_ennemies(&p);
		    	p.time_until_down=14;
		    	p.s_vy = 0;
		    	x = ((p.x+6)>>3)-1;
		    	y = ((((p.s_y)>>6)-3)>>3)-1;
		    	
		    	an[0].x = x << 3;
		    	an[0].y = y << 3;
		    	an[0].time = 10;
		    	an[0].p = &p;
		    	
		    	for (i=3;i--;) {
		    		an[0].animation_on_1[i]=(map[y+1][x+i] == 1);
		    		an[0].animation_on_2[i]=(map[y+1][x+i] == 73);
		    	}
		    }
				key_was_pressed=FALSE;
				//if (can_move_player) {
			    if(_keytest(RR_LEFT)) {
			      key_was_pressed = TRUE;
						if (p.s_vx > -0b101<<(H_S-2)) {
				      if (hit_bottom(&p)) {
				      	p.s_vx -= 1<<(H_S-(2+(on_ice(&p)<<2)));
				      }
				      else
				      {    	
				      	p.s_vx -= 1<<(H_S-2);
				      }
						}
			      p.s_x+=p.s_vx;
			      p.dir = DIR_LEFT;
				  }
				  else {
					  if(_keytest(RR_RIGHT)) {
				      key_was_pressed = TRUE;
				      if (p.s_vx < 0b101<<(H_S-2)) {
					      if (hit_bottom(&p))
								p.s_vx += 1<<(H_S-(2+(on_ice(&p)<<2)));
								else
								p.s_vx += 1<<(H_S-2);
							}
				      p.s_x+=p.s_vx;
				      p.dir = DIR_RIGHT;
				    }
			    }
		    //}
		    if (p.s_vx>0) {  
					while (hit_right(&p)) {
						p.s_x-=1<<H_S;
						p.s_vx = 0;
					}
				}
			  if (p.s_vx<0) {
			   	while (hit_left(&p)) {
						p.s_x+=1<<H_S;
						p.s_vx = 0;
					}
				}
				if (!key_was_pressed) {// && time&1) {
					if (p.s_vx!=0) {
						p.s_x+=p.s_vx;
						if (on_ice(&p)) {
							if (p.s_vx<0)
							p.s_vx+=1;
							else
							p.s_vx-=1;				
						}
						else
						{
							if (p.s_vx<0)
							p.s_vx+=1<<(H_S-2);
							else
							p.s_vx-=1<<(H_S-2);
							if (abs(p.s_vx) < 17)
							p.s_vx=0;
						}
						/*if (p.s_vx<0)
						p.s_vx+=1<<(H_S-(2+(on_ice(&p)<<2)));
						else
						p.s_vx-=1<<(H_S-(2+(on_ice(&p)<<2)));*/
					}
				}
				if (p.s_x > (256-8)<<H_S)
				p.s_x=(-8)<<H_S;
				if (p.s_x < (-8)<<H_S)
				p.s_x=(256-8)<<H_S;
				
				p.x = p.s_x>>H_S;
				p.y=p.s_y>>6;	
			}
			
			
			
			
			/***********************************
	  	*
	  	*	Calcul des coordonnes de la camra
	  	*
	  	***********************************/			
			if (p.dead) {
				p.x =  p.d.x;
				p.y = p.d.s_y>>V_S;		
			}
			if (TI89) {
				x_fg=(p.x-80+8);
			  if (x_fg <= 0)
			  x_fg = 0;
				if (x_fg > 256-160)
				x_fg = 256-160;
		    
		    y_fg = p.y-((100-16)/2)+scro.value;
		    if (y_fg < 72)
		    y_fg = 72;
		    if (y_fg > 38*8-100)
		   	y_fg = 38*8-100;
	   	}
	   	else
	   	{
	 			x_fg=(p.x-120+8);
			  if (x_fg <= 0)
			  x_fg = 0;
				if (x_fg > 256-240)
				x_fg = 256-240;
		    
		    y_fg = p.y-((128-16)/2)+scro.value;
		    if (y_fg < 72)
		    y_fg = 72;
		    if (y_fg > 38*8-128)
		   	y_fg = 38*8-128;  		
	   	}
			if (pow_has_been_hit) {
				pow_has_been_hit--;
				//x_fg+=random(3)-1;
				//y_fg+=random(3)-1;			
			}
			
			
	
			/***********************************
	  	*
	  	*	Gestion des mouvements des ennemis
	  	*
	  	**********************************/
	  	
	  	ENNEMI_STRUCT *E=e;
	   	for (i=MAX_ENNEMIES;i--;) {
		   	if (E->visible) {
			   	move_ennemies[E->move_function_id](E);
			   	if ((E->X.s_x < ((5*8)<<H_S) || E->X.s_x > ((25*8)<<H_S)) && (E->s_y > (270<<V_S))) {
						create_new_eip(E);
						delete_ennemi_in_array(E);
						if (E->X.id!=3)
						load_waiting_line(E);
						else
						E->reserved = FALSE;
						E->visible=FALSE;
						E->is_falling = FALSE;//useless (I think (but I am really not sure :s
					}
		   	}
		   	E++;
		  }
		  
		  
			
			/***********************************
	  	*
	  	*	Gestion des mouvements des fireball
	  	*
	  	***********************************/
	  	if (fireball_on) {
		  	if (!green_fireball.on && !mf[0].on && random(4)==0)
		  	init_green_fireball(&green_fireball,&(mf[0]),p.y);
				if (green_fireball.on)
				move_green_fireball(&green_fireball,&(mf[0]));
	  	}
	
	
			/***********************************
	  	*
	  	*	Gestion des mouvements des pices
	  	*
	  	***********************************/	
			COIN_STRUCT *c = coins;
			for (i=MAX_NUMBER_OF_COIN;i--;) {
				if (c->visible) {
					move_coin(c);
				}
				c++;//huhu
			}
			
			/***********************************
	  	*
	  	*	Gestion des stalagmites
	  	*
	  	***********************************/	
			
			if (stalag_on) {
				STALAG_STRUCT *s = stalag;
				for (i=4;i--;) {
					if (s->animation_on)
					move_stalag(s);
					else {
						if (random(CHANCE_TO_GET_A_STALAG)==0)
						create_stalag(s);
					}
					s++;
				}		
			}
			
	
			/***********************************
	  	*
	  	*	Animation du joueur qui court ou qui saute
	  	*
	  	***********************************/				
	    if (p.s_y != p.last_frame_s_y) {
	    	p.step = 3;
	    }
		  else
		  {
		   	if (p.last_frame_s_x != p.s_x && key_was_pressed) {
					p.inter_step++;
					if (p.inter_step==INTER_STEP_NUM) {
						p.inter_step = 0;
						p.step++;
						if (p.step >= STEP_NUM)
						p.step = 0;
					}
				}
				else
				{
					p.step = 0;
				}
			}
	
	
	
	  time++;
		if (time&11) {
	
	  	/***********************************
	  	*	Affichage du fond dans un buffer
	  	***********************************/  	  
		 	DrawPlane(x_fg,y_fg,&fg_plane,vecran,TM_GRPLC,TM_G8B);
		  FastCopyScreen_R(vecran,pl);
		  FastCopyScreen_R(vecran+LCD_SIZE,pd);
			
			
		
	  	/***********************************
	  	*	Affichage des pices qui sortent
	  	***********************************/  	
			for (i=MAX_COIN_IO;i--;) {
				if (cop[i].time) {
					move_coin_out(&cop[i]);
					draw_coin_io((COORD_STRUCT*)(&cop[i]),x_fg,y_fg);
				}
				if (cip[i].time) {
					move_coin_in(&cip[i]);
					draw_coin_io((COORD_STRUCT*)(&cip[i]),x_fg,y_fg);
				}
			}
			
	  	/***********************************
	  	*	Affichage des ennemies qui sortent
	  	***********************************/  	
	  				
			for (i=MAX_ENNEMI_IO;i--;) {
				if (eop[i].time) {
					draw_ennemi_out((ENNEMI_OUT_PIPE*)(&eop[i]),x_fg,y_fg);
				}
				if (eip[i].time) {
					draw_ennemi_in((ENNEMI_IN_PIPE*)(&eip[i]),x_fg,y_fg);
				}
			}
			
	 		/***********************************
	  	*	Affichage des mask
	  	***********************************/  		
			draw_masked_pipes(x_fg,y_fg);			
			
			
	  	/***********************************
	  	*	Affichage des blocks dforms
	  	***********************************/  	 			
		  for (i=1;i--;) {
				if (an[i].time) {
					an[i].time--;
					reverse_some_ennemies(an[i].x,an[i].y,an[i].p);
					if (green_fireball.on)
					check_if_fireball_explodes(&green_fireball,&mf[0],an[i].x,an[i].y,an[i].p);
					short a = an[i].time >> 1;
					for (y=2;y--;) {
						for (x=3;x--;) {
							if (an[i].animation_on_1[x] | an[i].animation_on_2[x]) {
								GrayClipISprite8_RPLC_R(an[i].x+(x<<3)-x_fg,an[i].y+(y<<3)-y_fg,8,anim_index[an[i].animation_on_2[x]][a][x][y],pl,pd);
							}
						}
					}
				}
			}    
	
	  	/***********************************
	  	*	Affichage de l'animation du sol qui se gele
	  	***********************************/  			
			for (i=MAX_NUMBER_OF_FREEZE_G;i--;) {
				if (freeze_g[i].on) {
					draw_frozen_ground(&(freeze_g[i]));
					fg_plane.force_update=TRUE;
				}
			}
	 
	 


	 
	 
			if (p.dead)  {//IF DA PLAYA IS DEAD
		  	
		  	
		  	/***********************************
		  	*	Affichage des ennemies
		  	***********************************/  
				for (i=MAX_ENNEMIES;i--;) {
					if (e[i].visible) {
						draw_ennemi(&(e[i]),x_fg,y_fg);
					}
				}
				
				
		  	/***********************************
		  	*	Affichage des green fireballz 
		  	***********************************/  
				if (green_fireball.on == TRUE) {
		 			draw_fireball((FIREBALL_STRUCT*)(&green_fireball),x_fg,y_fg);
		 		}

		  	/***********************************
		  	*	Affichage des stalag
		  	***********************************/  
				if (stalag_on) {
					for (i=MAX_NUMBER_OF_STALAG;i--;) {
						if (stalag[i].animation_on) {
							draw_stalag(&(stalag[i]),x_fg,y_fg);
							if (stalag[i].a<30) {
								if (collide_with_small_stalag(&(stalag[i]),&p)) {
									init_small_explosion(&ex_stalag[i],&(stalag[i]));
									stalag[i].animation_on = FALSE;
								}
							}
						}
						if (ex_stalag[i].time) 
						draw_exploding_stalag(&(ex_stalag[i]),x_fg,y_fg);
					}
				}
				
					
		  	/***********************************
		  	*	Affichage des pices
		  	***********************************/  	 		
				for (i=MAX_NUMBER_OF_COIN;i--;) {
					if (coins[i].visible) {
						draw_coin(&coins[i],x_fg,y_fg);			
					}
				}
				

			}	
			else//IF DA PLAYA AINT DEAD
			{
	
				
		  	/***********************************
		  	*	Affichage des green fireballz 
		  	***********************************/  
				if (green_fireball.on == TRUE) {
		 			draw_fireball((FIREBALL_STRUCT*)(&green_fireball),x_fg,y_fg);
		 			detect_collision_with_fireball(&p,&green_fireball);
		 		}
		 		
		 		
		  	/***********************************
		  	*	Affichage des stalag
		  	***********************************/  
				if (stalag_on) {
					for (i=MAX_NUMBER_OF_STALAG;i--;) {
						if (stalag[i].animation_on) {
							draw_stalag(&(stalag[i]),x_fg,y_fg);
							if (stalag[i].a<30) {
								if (collide_with_small_stalag(&(stalag[i]),&p)) {
									init_small_explosion(&ex_stalag[i],&(stalag[i]));
									stalag[i].animation_on = FALSE;
								}
							}
							else
							{
								STALAG_STRUCT* s = &(stalag[i]);
								if(COLLIDE( p.x+4,p.y+3, 8,16,  s->x+1,s->y,6,(s->a>36?14:8))) {
									kill_player(&p);
									init_small_explosion(&ex_stalag[i],&(stalag[i]));
									stalag[i].animation_on = FALSE;
								}
							
							}
						}
						if (ex_stalag[i].time) 
						draw_exploding_stalag(&(ex_stalag[i]),x_fg,y_fg);
					}
				}
				
					
		  	/***********************************
		  	*	Affichage des pices
		  	***********************************/  	 		
				for (i=MAX_NUMBER_OF_COIN;i--;) {
					if (coins[i].visible) {
						detect_collision_with_coin(&p,&(coins[i]));
						draw_coin(&coins[i],x_fg,y_fg);			
					}
				}
				
		  	/***********************************
		  	*	Affichage des ennemies
		  	***********************************/  
				
				for (i=MAX_ENNEMIES;i--;) {
					if (e[i].visible) {
						/*PortSet(pd,239,127);
						FontSetSys(2);
						DrawClipChar((e[i].X.s_x>>H_S)-x_fg+e[i].c+4,(e[i].s_y>>6)-y_fg-10,'0'+i,&(SCR_RECT){{0, 0, 239, 127}}, A_REVERSE);*/
						draw_ennemi(&(e[i]),x_fg,y_fg);
						
						//DrawClipChar(10,10,'0',&(SCR_RECT){{0, 0, 159, 99}}, A_REVERSE);
						//cos(1);
						/*char ss[20];
						sprintf(ss,"%u %u %u %u",i,e[i].X.s_x>>H_S,e[i].s_y>>V_S,COLLIDE( p.x+4,p.y+3, 8,16,  e[i].x+1,e[i].y+3, 14,13));
						GrayDrawStr2B(i*6,10,ss,A_REPLACE,pl,pd);
						GrayDrawStr(i*6,10,ss,A_REPLACE);*/
						detect_collision_with_ennemi(&p,&(e[i]));
					}
				}
			}
			
	  	/***********************************
	  	*	Affichage des anims
	  	***********************************/  		
			for (i=MAX_ANIM;i--;) {
			 	if (anim[i].time)
			 	draw_anim(&(anim[i]),x_fg,y_fg);
			 	if (score_anim[i].time)
			 	draw_score_anim(&(score_anim[i]),x_fg,y_fg);
			}
			
	  	/***********************************
	  	*	Affichage des ennemies en train de crever
	  	***********************************/
			for(i=MAX_DEAD_ANIM;i--;) {
				if (dead_anim[i].on)
				draw_dead_anim(&(dead_anim[i]),x_fg,y_fg);
			}
		
	  	/***********************************
	  	*	Affichage des explosions des iceman
	  	***********************************/  		
			for (i=number_of_icemen_explosion;i--;)
			draw_exploding_icemen(i,x_fg,y_fg);			
			
	  	/***********************************
	  	*	Affichage des petites fireballz
	  	***********************************/  			
			for (i=2;i--;) {
	 			if (mf[i].on)
	 			draw_mini_fireball(&mf[i],x_fg, y_fg);		
	 		}
			
			
			
	

			
		  /***********************************
	  	*	Affichage de mario
	  	***********************************/			
			if (p.re.time_down | p.re.block_time) {
				draw_respawn(&p,x_fg,y_fg);
			}
			else
			{
				draw_mario(&p,x_fg,y_fg);
			}
			
	 		/***********************************
	  	*
	  	*	Copiage du buffer vers l'cran
	  	*
	  	***********************************/ 
			if (show_level_num) {
				show_level_num--;
				char pipi[15];
				const char lulu[] = {'0'-5,'1'-5,'2'-5,'3'-5,'4'-5,' ','%','d',*""};
				sprintf(pipi,lulu,level_num);
		
				i=0;
				while (pipi[i]) {
					char xx=(LCD_WIDTH-8*8)>>1;
					char yy=((LCD_HEIGHT-20)>>1);
					if (pipi[i]!=' ')
					GraySprite8_TRANW_R(xx+(i<<3),yy,16,&phase_sprites_1[(pipi[i]-'0'+5)<<4],&phase_sprites_2[(pipi[i]-'0'+5)<<4],pd,pl);
					i++;
				}
			}
			
			if (number_of_ennemies_in_level==0 || show_clear) {
				if  (TI89)
				GraySpriteX8_MASK((160-7*8)/2,(100-16)/2,16,clear_1,clear_2,clear_mask,clear_mask,7,pd,pl);
				else
				GraySpriteX8_MASK((240-7*8)/2,(128-16)/2,16,clear_1,clear_2,clear_mask,clear_mask,7,pd,pl);

				if (show_clear == 0) {
					show_clear = 40;
				}
				show_clear--;
				if (show_clear==1)
				jump_to_next_level = TRUE;
			}
				
			draw_score(p.score);
			FastCopyScreen_R(pl,GetPlane(LIGHT_PLANE));
			FastCopyScreen_R(pd,GetPlane(DARK_PLANE));
			//drh();
		}
		else		//SI ON AFFICHE PAS, ON DTECTE LES COLLISIONS (ON ESSAIE EN TOUT CAS>>>)
		{		
			
			ChangeContrast();
			if (_keytest(RR_PLUS))
			OSContrastUp();
			if (_keytest(RR_MINUS))
			OSContrastDn();
			
			
			for (i=2;i--;) {
				if (pipes[i].time) {
					pipes[i].time--;
				}
				else {
					pipes[i].time =15;
	
					if (number_of_coin_to_init) {
						number_of_coin_to_init--;
						create_new_coin_going_out(i,cop);
						pipes[i].time =30;
					}
					else
					{
						if (slipice_on) {
							if ((random(6)<2)) {
								short j=0;
								while (e[j].reserved == TRUE) {j++;};
						  	e[j].sprite = ennemie_sprites[ID_SLIPICE];
						  	e[j].move_function_id  = ID_SLIPICE;
						  	e[j].visible=FALSE;
						  	e[j].X.must_be_reversed = FALSE;
						  	e[j].X.id = ID_SLIPICE;
						  	//e[j].X.s_x = 0;
						  	//e[j].s_y = 0;
						  	e[j].reserved = TRUE;
						  	short k=0;
						  	while (ennemi_to_be_initialized[k]!=NULL) {k++;};
						  	ennemi_to_be_initialized[k]=ennemi_to_be_initialized[0];
						  	ennemi_to_be_initialized[0] = &(e[j]);
						  	e[j].visible = FALSE;
						  	e[j].b = 0;
						  	e[j].speed = 0;
							}
						}
						empty_waiting_line(i);
					}
				}
			}
			check_all_collision();
		}
		
		
	  } while(!quit && !jump_to_next_level);
  } while(!quit);
  while (_keytest(RR_ENTER));
  update_score(p.score, level_num);
}

//!yacas cos(x):="Tu sux"
//http://www.amiga2.free.fr/alchimie4/diapos_600/Alchimie_IV_084.jpg
//Comme un dieu
//sexy boy
// !yacas start():=[a:=Random();"f";]
//10h au macdo
//flo: 0609659491
//Je suis complemtement bourr. il est 10:43pom, et je ai une l
//
//MM: 0141813519 ou 06 32 20 74 82 ou 0870357816
//